<?php
/*
Plugin Name: Invitext
Plugin URI: http://invitext.ru
Description: A plugin that add security strings to posts.
Author: idea/development: Alexander.Khoroshilov@invitext.ru
Version: 1.01
Author URI: http://invitext.ru
Text Domain: invitext
*/

add_action('wp_head', 'inv_header');

define(LINK_URL,"<a href='http://invitext.ru/'>защищено INVITEXT</a>");
define(CONTAINER_END,"</span></noindex>");
define(CONTAINER_BEGIN_1,"<noindex><span class=\"");
define(CONTAINER_BEGIN_2,"\">");

$spec_span = random_span(6);

function random_span($length) {  
    $possibleCharacters =  "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";  
    $characterLength = strlen($possibleCharacters);  
    $seed = (double) microtime() * 1000000;  
    srand($seed);  
    $rnd_span = "";  
     for($i=1;$i<=$length;$i++){  
      $character = rand(1,$characterLength);  
      $character = substr($possibleCharacters,$character, 1);  
      $rnd_span .= $character;  
    }  
return $rnd_span;  
}  


function inv_header( )
{
   global $spec_span;

    echo "\n<style type='text/css'>";
    echo "\nspan.".$spec_span." {";
    echo "\nfont-size: 1px;"; 
    echo "\nletter-spacing: -1px;";
    echo "\nopacity: 0.0;";
    echo "\n}";
    echo "\n</style>";


    echo "\n<!--[if IE]>"; 
    echo "\n<style type='text/css'>";
    echo "\nspan.".$spec_span." {";
    echo "\nfont-size: 1px;"; 
    echo "\nletter-spacing: -1px;";
    echo "\n visibility: hidden;";
    echo "\n}";
    echo "\n</style>";
    echo "\n<![endif]-->";
}

/*
Функция выводит массив установленных модулей в php
*/
function phpinfo_array($return=false){
 /* Andale!  Andale!  Yee-Hah! */
 ob_start();
 phpinfo(-1);
 
 $pi = preg_replace(
 array('#^.*<body>(.*)</body>.*$#ms', '#<h2>PHP License</h2>.*$#ms',
 '#<h1>Configuration</h1>#',  "#\r?\n#", "#</(h1|h2|h3|tr)>#", '# +<#',
 "#[ \t]+#", '#&nbsp;#', '#  +#', '# class=".*?"#', '%&#039;%',
  '#<tr>(?:.*?)" src="(?:.*?)=(.*?)" alt="PHP Logo" /></a>'
  .'<h1>PHP Version (.*?)</h1>(?:\n+?)</td></tr>#',
  '#<h1><a href="(?:.*?)\?=(.*?)">PHP Credits</a></h1>#',
  '#<tr>(?:.*?)" src="(?:.*?)=(.*?)"(?:.*?)Zend Engine (.*?),(?:.*?)</tr>#',
  "# +#", '#<tr>#', '#</tr>#'),
 array('$1', '', '', '', '</$1>' . "\n", '<', ' ', ' ', ' ', '', ' ',
  '<h2>PHP Configuration</h2>'."\n".'<tr><td>PHP Version</td><td>$2</td></tr>'.
  "\n".'<tr><td>PHP Egg</td><td>$1</td></tr>',
  '<tr><td>PHP Credits Egg</td><td>$1</td></tr>',
  '<tr><td>Zend Engine</td><td>$2</td></tr>' . "\n" .
  '<tr><td>Zend Egg</td><td>$1</td></tr>', ' ', '%S%', '%E%'),
 ob_get_clean());

 $sections = explode('<h2>', strip_tags($pi, '<h2><th><td>'));
 unset($sections[0]);

 $pi = array();
 foreach($sections as $section){
   $n = substr($section, 0, strpos($section, '</h2>'));
   preg_match_all(
   '#%S%(?:<td>(.*?)</td>)?(?:<td>(.*?)</td>)?(?:<td>(.*?)</td>)?%E%#',
     $section, $askapache, PREG_SET_ORDER);
   foreach($askapache as $m)
       $pi[$n][$m[1]]=(!isset($m[3])||$m[2]==$m[3])?$m[2]:array_slice($m,2);
 }

 return ($return === false) ? print_r($pi) : $pi;
}

$phpinfo_array=phpinfo_array(1);
if (array_key_exists('mbstring', $phpinfo_array)) 
	add_filter('the_content','add_strings_plugin', 15);
add_action('init', 'init_add_strings_textdomain');

include_once( 'rc-custom-field-gui.class.php' );
//add_action( 'simple_edit_form', array( 'rc_custom_field_gui', 'insert_gui' ));
//add_action( 'edit_form_advanced', array( 'rc_custom_field_gui', 'insert_gui' ) );
//add_action('edit_page_form', array( 'rc_custom_field_gui', 'insert_gui' ));
add_action( 'edit_post', array( 'rc_custom_field_gui', 'edit_meta_value' ) );
add_action( 'save_post', array( 'rc_custom_field_gui', 'edit_meta_value' ) );
add_action( 'publish_post', array( 'rc_custom_field_gui', 'edit_meta_value' ) );
require_once(ABSPATH . 'wp-admin/includes/template.php');
			add_meta_box('cftdiv', __('Invitext options','invitext'), array( 'rc_custom_field_gui', 'insert_gui' ), 'post', 'normal', 'core');
			add_meta_box('cftdiv', __('Invitext options','invitext'), array( 'rc_custom_field_gui', 'insert_gui' ), 'page', 'normal', 'core');
 
function init_add_strings_textdomain(){
  load_plugin_textdomain('invitext',PLUGINDIR . '/' . dirname(plugin_basename (__FILE__)) . '/lang');
}

$word_every_n=-1;
$as_n_db=get_option('as_n');
$as_string_db=get_option('as_string');
$as_symbols_db=get_option('as_symbols');
$as_link_db=get_option('as_link');

$as_n=$as_n_db;
$as_string=$as_string_db;
$as_symbols=$as_symbols_db;
$as_link=$as_link_db;

/**
Main plugin code
add string to the post

@param string $content the original content of the post
@return string $content the modified content of the post
*/
function add_strings_plugin($content)
{
global $spec_span, $word_every_n, $as_n, $as_link,$as_n_db, $as_link_db,$as_string,$as_string_db ,$as_symbols,$as_symbols_db, $post, $id;
	if (is_single() || is_page()) {
	
		$as_n = get_post_meta($post->ID, 'n', $single = true);
		if (!$as_n) $as_n=$as_n_db; 
		$word_every_n=$as_n;
	
		$as_string = get_post_meta($post->ID, 'string', $single = true);
		if (!$as_string) $as_string=$as_string_db;
		
		$as_symbols = get_post_meta($post->ID, 'symbols', $single = true);
		if (!$as_symbols) $as_symbols=$as_symbols_db;
	
		$as_link = get_post_meta($post->ID, 'link', $single = true);
		if ($as_link==="0"||$as_link==="1") {
			if ($as_link==="1") $as_link="true";
			if ($as_link==="0") $as_link="false";
		}
		else {
			$as_link=$as_link_db;
		}
		if ($as_n>0&&$as_string)
			//$content=preg_replace_callback( "|\s|", "as_next_word", $content);
			// не вставляем в теги слова
			$content=preg_replace_callback( "@(?![^<]*>)\s@", "as_next_word", $content);
		
		if ($as_link==="true")
                              
			$content.=" ".LINK_URL;
                              
		}
		
	return $content;
}
/*
Функция вызывается как только найдено слово. Каждые n слов добавляем новое слово
*/
function as_next_word($matches){
	global $spec_span, $word_every_n, $as_n, $as_string,$as_symbols;
	
	
	if (--$word_every_n<=0) {
		$word_every_n=$as_n;
		$the_string=CONTAINER_BEGIN_1.$spec_span.CONTAINER_BEGIN_2.as_get_modified_string($as_string,$as_symbols).CONTAINER_END;
		return $matches[0].$the_string." ";
	}
	else return $matches[0];
}
/*
получаем готовую для вставки в текст строку, модифицированную символами
В строке символы могут повторяться, отсутствовать, но никогда – идти подряд. Допускается до 3-х символов включительно.
*/
function as_get_modified_string($str,$add_symbols){
	mb_internal_encoding("UTF-8");
	$previous_occ=Array();
	if ($add_symbols) 
	for ($i=0;$i<3;$i++){
		$char=mb_substr($add_symbols,rand(0,mb_strlen($add_symbols)-1),1);
		//но никогда – идти подряд
		while (in_array($position,$previous_occ)){
			$position=rand(1,mb_strlen($str));
		}
		
		$str=mb_substr($str, 0, $position).$char.mb_substr($str, $position);
		foreach ($previous_occ as &$pos) {
			if ($pos>$position)
				$pos = $pos +1;
		}
		$previous_occ[]=$position;
		$previous_occ[]=$position+1;
	}
	
	return $str;
}
//Register menu in admin page

if ( is_admin() ){ // admin actions
  add_action('admin_menu', 'wp_add_strings_admin_menu');
} else {
  // non-admin enqueues, actions, and filters
}


function wp_add_strings_admin_menu() {
	if (function_exists('add_options_page')) {
		  // Add a new submenu under Options:
		add_options_page(__('Invitext options','invitext'), __('Invitext options','invitext'),
		'administrator', 'add_strings_options', 'add_strings_options_page');

	}
}

// mt_options_page() displays the page content for the Test Options submenu
function add_strings_options_page() {

    $hidden_field_name = 'add_strings_submit_hidden';

    // See if the user has posted us some information
    // If they did, this hidden field will be set to 'Y'
    if( $_POST[ $hidden_field_name ] == 'Y' ) {

        // Save the posted value in the database
		if (mb_strlen($_POST['as_string'])>20) 
			echo '<div class="updated"><p><strong>'. __('String length should be less 20. String cut at 20 chars', 'invitext' ).'</strong></p></div>';
		update_option( 'as_string', mb_substr($_POST['as_string'],0,20));
		if ((int)$_POST['as_n']<50) {
			echo '<div class="updated"><p><strong>'. __('Frequency of occurrence should be greater 50. Set to 50.', 'invitext' ).'</strong></p></div>';
			update_option( 'as_n', 50);
		}
		else
			update_option( 'as_n', (int)$_POST['as_n']);
		update_option( 'as_symbols', $_POST['as_symbols'] );
		if ($_POST['as_link']){
			update_option( 'as_link', "true" );
		}
		else
		{
			update_option( 'as_link', "false" );
		}
        // Put an options updated message on the screen

?>
<div class="updated"><p><strong><?php _e('Options saved.', 'invitext' ); ?></strong></p></div>
<?php

    }
	$phpinfo_array=phpinfo_array(1);
	if (!array_key_exists('mbstring', $phpinfo_array)) 
		echo '<div class="error"><p><strong>'. __('Warning! Php module mbstring not found! Enable this module in php.ini to activate this plugin.', 'invitext' ).'</strong></p></div>';
    // Now display the options editing screen

    echo '<div class="wrap">';

    // header

    echo "<h2>" .  __('INVITEXT Options','invitext') . "</h2>";

    // options form
    
    ?>


<form name="form1" method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>?page=add_strings_options">
<input type="hidden" name="<?php echo $hidden_field_name; ?>" value="Y">

<?php wp_nonce_field('update-options'); ?>

<table class="form-table">

<tr valign="top">
<th scope="row"><?php _e('String', 'invitext' ) ?></th>
<td><input type="text" name="as_string" size=20 value="<?php echo get_option('as_string'); ?>" /></td>
</tr>
 
<tr valign="top">
<th scope="row"><?php _e('Frequency of occurrence', 'invitext' ) ?></th>
<td><input type="text" name="as_n" size=3 value="<?php echo get_option('as_n'); ?>" /></td>
</tr>

<tr valign="top">
<th scope="row"><?php _e('Additional Symbols', 'invitext' ) ?></th>
<td><input type="text" name="as_symbols" size=20 value="<?php echo get_option('as_symbols'); ?>" /></td>
</tr>

<tr valign="top">
<th scope="row"><?php _e('Add link', 'invitext' ) ?></th>
<td><input type="checkbox" name="as_link" value="1" checked <?php echo ((get_option('as_link')=="true")?"checked":""); ?> /></td>
</tr>

</table>


<hr />

<p class="submit">
<input type="submit" name="Submit" value="<?php _e('Save options', 'invitext' ) ?>" />
</p>

</form>
Welcome to other my site about night pictures:<a href='http://night-photo.ru' target="_blank">night-photo.ru </a>
</div>

<?php
 
}


?>
